#ifndef _ECRITURE_H
#define _ECRITURE_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Structure de tampon pour l'criture bit  bit */
typedef struct _filebab {
    FILE * fichier; /* Fichier lu */
    char * mode; /* Mode du fichier */
    unsigned char tampon; /* Tampon de lecture */
    int bit; /* Prochain bit lu */
} FileBAB;

/* Prototypes */

/* crit un bit dans le fichier 
 * L'criture relle ne se fait que quand l'octet de tampon est complet 
 * Retourne 1 si l'criture  russi, 0 sinon
 */
int ecrirebit(FileBAB * fichier, char bit);
/* 
 * Lit un bit dans le fichier
 * Retourne 1 si l'criture  russi, 0 sinon
 */
int lirebit(FileBAB * fichier, char * bit);
/* 
 * Ouvrir un fichier
 */
FileBAB * ouvrir(char * nom_fichier, char * mode);
/* 
 * Ferme un fichier, crit avant le contenu du tampon en le compltant
 * si ncessaire
 */
void fermer(FileBAB * fichier);


/* 
 * crit nbbits de la zone pointe par ptr
 */
int ecrire(FileBAB * fichier, void * ptr, int taille);
/* 
 * crit un char dans le fichier
 */
int ecrire_car(FileBAB * fichier, char c);
/* 
 * Lit une chaine de caractres dans un fichier de type FileBAB
 */
int lirechaine(FileBAB * fichier, char ** chaine, int * taille);
/*
 * Lit un caractre dans un fichier de type FileBAB
 */
int lire_car(FileBAB * fichier, char * car);


/*
 * Retourne le nombre de bits "utiles" dans un entier
 */
unsigned int nbbits(unsigned int n);
/* 
 * crit l'entier n en utilisant le codage bit  bit :
 *  - nombre de bits ncessaires  son enregistrement cod de faon unaire
 *  - 0
 *  - entier n
 */
int ecrirebitabit(FileBAB * fichier, unsigned int n);
/* 
 * Lit un entier et le place dans n en utilisant le codage bit  bit
 * ( idem  la fonction ecrirebitabit )
 */
int lecturebitabit(FileBAB * fichier, unsigned int * n);

/*
 * crit un entier n en utilisant le codage octet par octet
 * On crit par paquet de 7 bits et un huitime indique si l'criture se
 * poursuit sur l'octet suivant ou non.
 */
int ecrireoctetparoctet(FileBAB * fichier, unsigned int n);
/*
 * Lit un entier en utilisant le codage octet par octet ( cf au dessus ) 
 */
int lectureoctetparoctet(FileBAB * fichier, unsigned int * n);

#endif /* _ECRITURE_H */
