#ifndef _INCLUDE_H
#define _INCLUDE_H

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

typedef struct cellule_ {
    char * mot;
    struct cellule_ * suiv;
} cellule, * liste;

/* 
 * Alloue de la mmoire pour stocker mot dans une cellule de liste chaine
 */
cellule * creer_cellule(char * mot);
/* 
 * Dtruit la liste chaine pointe
 */
void detruire_liste(liste l);


/*
 * Ajoute mot  la fin de la liste l
 */
cellule * ajouter_fin_liste(liste * l, char * mot);
/*
 * Ajoute un caractre  la fin de la liste l ( de caractres ! )
 */
cellule * ajouter_fin_liste_c(liste * l, char mot);


/* 
 * Dplace la cellule c en tte de la liste l
 */
void met_en_tete(liste * l, cellule * c);


/* 
 * Retourne le mot dans la liste et met sa position dans *position
 * Note : 1 correspond au premier mot de la liste ( l->mot )
 *        0 correspond donc  l'absence du mot dans la liste.
 */
cellule * recherche(liste l, char * mot, int * position);
/* 
 * Retourne le caractre dans la liste ( de caractres ! ) et met sa position 
 * dans *position
 * Note : position = 1 : correspond au premier mot de la liste ( l->mot )
 *        position = 0 : correspond donc  l'absence du mot dans la liste.
 */
cellule * recherche_c(liste l, char mot, int * position);


/* 
 * Retourne la cellule en position n
 */
cellule * position(liste l, int n);

/*
 * Affiche une liste de mots ( un par ligne )
 */
void afficher_liste(liste l);

/*
 * Affiche une liste de caractres ( un par ligne )
 */
void afficher_liste_c(liste l);

#endif /* _INCLUDE_H */
