#include <main.h>

int main(int argc, char **argv)
{
    int verbose = 0;
    char c;
    int (*lecture)(FileBAB * fichier, unsigned int * n) = lecturebitabit;
    int (*ecriture)(FileBAB * fichier, unsigned int n) = ecrirebitabit;

    /* Lecture des arguments de la ligne de commande */
    while ( (c = getopt(argc, argv, "bov")) != -1 ) {
	switch(c) {
	    case 'b':
		lecture = lecturebitabit;
		ecriture = ecrirebitabit;
		break;
	    case 'o':
		lecture = lectureoctetparoctet;
		ecriture = ecrireoctetparoctet;
		break;
	    case 'v':
		verbose = 1;
		break;
	    case '?':
		fprintf(stderr,"Option -%c inconnue\n",optopt);
		break;
	}
    }
    
    /* Dcompression ? */
    if ( strcmp(basename(argv[0]), "decompress") == 0 ) {
	if ( optind <= argc-2 ) {
	    printf("Dcompression de %s vers %s\n",
		    argv[optind], argv[optind+1]);
	    if ( decompress(argv[optind], argv[optind+1], lecture, verbose) ) {
		puts("Dcompression russie");
		return 0;
	    }
	    fprintf(stderr,"Erreur  la dcompression !\n");
	    return 1;
	} else {
	    fprintf(stderr,"Usage : %s [-b] [-o] [-v] <fichier  dcompresser> "
		    "<fichier dcompress>\n", argv[0]);
	    return 1;
	}
    } else if ( strcmp(basename(argv[0]), "compress") == 0 ) {
    /* Compression ? */
	if ( optind <= argc-2 ) {
	    printf("Compression de %s vers %s\n",
		    argv[optind], argv[optind+1]);
	    if ( compress(argv[optind], argv[optind+1], ecriture, verbose) ) {
		puts("Compression russie");
		return 0;
	    }
	    fprintf(stderr,"Erreur  la compression !\n");
	    return 1;
	} else {
	    fprintf(stderr,"Usage : %s [-b] [-o] [-v] <fichier  compresser> "
		    "<fichier compress>\n", argv[0]);
	    return 1;
	}
    } else {
    /* Huh ?! */
	fprintf(stderr,"Fonction inconnue : %s\n", basename(argv[0]));
	return 1;
    }


    return 0;
}
