#include <parseur.h>

/* 
 * Initialise le parseur
 */
Mots * init_parseur(char * fichier)
{
    Mots * m = NULL;

    m = malloc(sizeof(Mots));
    if ( m == NULL )
	return NULL;

    m->ligne = NULL;
    m->tampon = 0;
    m->longueur = 0;
    m->position = 0;
    m->fichier = fopen(fichier, "r");
    if ( m->fichier == NULL ) {
	free(m);
	return NULL;
    }

    return m;
}

/* 
 * Termine le parseur
 */
void fin_parseur(Mots * m)
{
    free(m->ligne);
    fclose(m->fichier);
    free(m);
}

/*
 * Lit un mot. Le parseur lit une nouvelle ligne avec getline si celle lue
 * en cours est termine puis cherche le prochain sparateur de mot ( 0, \n ou
 * espace ), le remplace par un 0 et incrmente position de manire  trouver
 * le prochain lors du prochain appel  lire_mot
 * Retourne la ponctuation sur laquelle la lecture s'est arrte.
 */
char lire_mot(Mots * m, char ** mot)
{
    char ret = 1;

    if ( m->position >= m->longueur ) {
	m->longueur = getline(&(m->ligne), &(m->tampon), m->fichier);
	if ( m->longueur == -1 )
	    return 0;
	m->position = 0;
    }
    
    *mot = &(m->ligne[m->position]);
    
    while ( m->ligne[m->position] != ' ' 
	    && m->ligne[m->position] != 0
	    && m->ligne[m->position] != '\n'
	    && m->ligne[m->position] != ','
	    && m->ligne[m->position] != '.'
	    && m->ligne[m->position] != '\t'
	    && m->ligne[m->position] != ';'
	    && m->ligne[m->position] != ':' )
	m->position++;

    if ( ret != 0 )
	ret = m->ligne[m->position];

    m->ligne[m->position] = 0;
    m->position++;

    return ret;
}

