#include <progress.h>

/*
 * Retourne la largeur du terminal
 */
int largeur_terminal(void)
{
    int largeur_terminal;
    char * columns = NULL;
    struct winsize ws;

    /* Largeur du terminal sur System V */
    if ( (columns = getenv("COLUMNS")) != NULL )
	largeur_terminal = (int) strtol(columns, NULL, 10);
    /* Largeur du terminal sur systme Berkeley */
    else if ( ioctl(1, TIOCGWINSZ, &ws) == 0 )
	largeur_terminal = ws.ws_col;
    /* Valeur par dfaut */
    else
	largeur_terminal = 80;

    return largeur_terminal;
}

/*
 * Affiche une barre de progression  l'tat pos/max, de la largeur du terminal
 */
void progressbar(int pos, int max, int largeur_terminal)
{
    if ( largeur_terminal <= 3 )
	return;

    /* On diminue la largeur du terminal du nombre de caractres ncessaires
     *  '[' ']' et '>'
     */
    largeur_terminal = largeur_terminal-3;
    int i=0, compteur;
    /* Affichage de la barre de progression */
    compteur = (int)( pos/(float)max * largeur_terminal);

    /* Retour en dbut de ligne */
    putc('\r',stderr);

    /* Compteur */
    putc('[', stderr);
    if ( compteur > 1 ) 
	for ( ; i < compteur ; i++ )
	    putc('-', stderr);
    putc('>',stderr);
    for ( ; i < largeur_terminal ; i++ )
	putc(' ',stderr);
    putc(']',stderr);
}
